'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createEpicMiddleware = createEpicMiddleware;

var _Subject = require('rxjs/Subject');

var _from = require('rxjs/observable/from');

var _ActionsObservable = require('./ActionsObservable');

function createEpicMiddleware(epic) {
  var actions = new _Subject.Subject();
  var actionsObs = new _ActionsObservable.ActionsObservable(actions);

  var middleware = function middleware(store) {
    return function (next) {
      if (epic) {
        epic(actionsObs, store).subscribe(store.dispatch);
      }
      return function (action) {
        if (typeof action === 'function') {
          if (typeof console !== 'undefined' && typeof console.warn !== 'undefined') {
            console.warn('DEPRECATION: Using thunkservables with redux-observable is now deprecated in favor of the new "Epics" feature. See http://redux-observable.js.org/docs/FAQ.html#why-were-thunkservables-deprecated');
          }

          var obs = (0, _from.from)(action(actionsObs, store));
          var sub = obs.subscribe(store.dispatch);
          return sub;
        } else {
          var result = next(action);
          actions.next(action);
          return result;
        }
      };
    };
  };

  return middleware;
}